#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__="atareao"
__date__ ="$24-abr-2010 12:34:44$"
#
# <one line to give the program"s name and a brief idea of what it does.>
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#

import sys
import gtk
import time
import urllib
import urllib2
import ConfigParser
import os
import gobject
from os import path
from gdata.service import BadAuthentication
import threading
import webbrowser
#
import picasa
from picasa import Picasa
from nuevoalbum import NuevoAlbum
from informacionalbum import InformacionAlbum
from editalbum import EditAlbum
from editimage import EditImage
from informacionimagen import InformacionImagen
from verimagen import VerImagen
#
from preferences import Preferences
from progreso import Progreso
from comun import filepath
import gkconfiguration
import comun
#
from threading import Thread
import locale
import gettext
import gdata
# Reducing
import tempfile
import shutil
from PIL import Image
import re, htmlentitydefs

import mimetypes

TARGET_TYPE_TEXT = 80
TARGET_TYPE_PIXMAP = 81


locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(comun.APP, comun.LANGDIR)
gettext.textdomain(comun.APP)
_ = gettext.gettext

def unescape(text):
	def fixup(m):
		text = m.group(0)
		if text[:2] == "&#":
			# character reference
			try:
				if text[:3] == "&#x":
					return unichr(int(text[3:-1], 16))
				else:
					return unichr(int(text[2:-1]))
			except ValueError:
				pass
		else:
			# named entity
			try:
				text = unichr(htmlentitydefs.name2codepoint[text[1:-1]])
			except KeyError:
				pass
		return text # leave as is
	return re.sub("&#?\w+;", fixup, text)

def add2menu(menu, text = None, icon = None, conector_event = None, conector_action = None):
	if text != None and icon == None:
		menu_item = gtk.MenuItem(text)
	elif text == None and icon != None:
		menu_item = gtk.ImageMenuItem()
		image = gtk.Image()
		image.set_from_stock(icon,gtk.ICON_SIZE_MENU)
		menu_item.set_image(image)
		menu_item.set_always_show_image(True)
	elif text != None and icon != None:
		menu_item = gtk.ImageMenuItem(text)
		image = gtk.Image()
		image.set_from_stock(icon,gtk.ICON_SIZE_MENU)
		menu_item.set_image(image)
		menu_item.set_always_show_image(True)
	elif icon == None:
		menu_item = gtk.MenuItem(text)
	else:
		menu_item = gtk.SeparatorMenuItem()
	if conector_event != None and conector_action != None:				
		menu_item.connect(conector_event,conector_action)
	menu_item.show()
	menu.append(menu_item)
	return menu_item
	
def resize_image(filename,size,colors):
	image = Image.open(filename)
	w,h = image.size
	if size == True and (w>800 or h>800):
		maximo = 800
		if w > h:
			h = h * maximo/w
			w = maximo
		else:
			w = w * maximo/h
			h = maximo
		image = image.resize([w,h],Image.ANTIALIAS)
	if colors == True:
		image = image.convert('P',palette = Image.WEB)
	image.save(filename)
		
class Uploader(Thread):
	def __init__ (self,progreso,window,filename,album,picasa,storeimages,size,colors):
		Thread.__init__(self)
		self.filename = filename
		self.picasa = picasa
		self.storeimages = storeimages
		self.album = album
		self.window = window
		self.progreso = progreso
		self.status = -1
		self.size = size
		self.colors = colors

	def run(self):
		name=os.path.basename(self.filename)[:-4]
		wait = 1
		uploaded = False
		print 'uploading ',self.filename
		while not uploaded:
			try:
				self.window.map()
				while gtk.events_pending():
					gtk.main_iteration()				
				self.photo=self.picasa.add_image(self.album.gphoto_id.text,self.filename,name,name,self.size,self.colors)
				self.status = 0
				uploaded = True
			except:
				time.sleep(wait)
				wait = wait + 1
		print 'uploaded ',self.filename
		print 'downloading ',self.filename
		self.progreso.increase()
		download_one_image(self.window,self.photo,self.storeimages)
		print 'downloaded ',self.filename
		self.window.map()
		while gtk.events_pending():
			gtk.main_iteration()				

	def get_photo(self):
		return self.photo

class DownloaderManager:
	def __init__(self,window,photos,storeimages):
		self.photos = photos
		self.storeimages = storeimages
		self.downloaders = []
		self.window = window
	
	def download(self):
		print len(self.photos)
		#,title,parent,max_value
		p = Progreso(_('Downloading images'),self.window,len(self.photos))
		for photo in self.photos:
			while(len(self.downloaders) > 10):
				for down in self.downloaders:
					if down.is_running() == False:
						self.downloaders.remove(down)
				self.window.map()
				while gtk.events_pending():
					gtk.main_iteration()				
			dm=Downloader(photo, self.storeimages)
			dm.start()
			self.window.map()
			while gtk.events_pending():
				gtk.main_iteration()				
			self.downloaders.append(dm)
			p.increase()

def download_one_image(window,photo,storeimages):
	downloaded = False
	wait = 1
	while not downloaded:
		try:
			while gtk.events_pending():
				gtk.main_iteration()				
			f = urllib.urlopen(photo.media.thumbnail[0].url)
			data = f.read()
			pbl = gtk.gdk.PixbufLoader()
			pbl.write(data)
			pbuf = pbl.get_pixbuf()
			pbl.close()
			downloaded = True
		except:
			time.sleep(wait)
			wait = wait + 1
	storeimages.append([pbuf,photo.title.text,photo])
	window.map()
	while gtk.events_pending():
		gtk.main_iteration()				
	

class Downloader(Thread):
	def __init__ (self,photo,storeimages):
		Thread.__init__(self)
		self.photo = photo
		self.storeimages = storeimages
		self.running = True

	def run(self):
		f = urllib.urlopen(self.photo.media.thumbnail[0].url)
		data = f.read()
		pbl = gtk.gdk.PixbufLoader()
		pbl.write(data)
		pbuf = pbl.get_pixbuf()
		pbl.close()
		self.storeimages.append([pbuf,self.photo.title.text,self.photo])		
		self.running = False
	
	def is_running(self):
		return self.running

class Saver(Thread):
	def __init__ (self,photo,folder):
		Thread.__init__(self)
		self.photo = photo
		self.folder = folder
		self.running = True

	def run(self):
		f = urllib.urlopen(self.photo.content.src)
		data = f.read()
		pbl = gtk.gdk.PixbufLoader()
		pbl.write(data)
		pbuf = pbl.get_pixbuf()
		pbl.close()
		if pbuf != None:
			filename = self.photo.content.src[self.photo.content.src.rfind('/')+1:]
			extension = os.path.splitext(filename)[1][1:]
			if extension.lower() == 'jpg':
				extension = 'jpeg'
			path = os.path.join(self.folder,filename)
			pbuf.save(path,extension)
		self.running = False
	
	def is_running(self):
		return self.running

class Picapy(gtk.Window):
	
	def __init__(self):
		gtk.Window.__init__(self)
		self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		self.set_title(comun.APP)
		self.set_default_size(750, 600)
		self.set_icon(gtk.gdk.pixbuf_new_from_file(comun.ICON))
		self.connect('destroy', self.close_application)
		#
		if gkconfiguration.exists_configuration()==False:
			p = Preferences(self)
		self.load_preferences()
		error = True
		while error:
			try:
				self.picasa=Picasa(self.user,self.password)
				error = False
			#except BadAuthentication:
			except:
				error = True
				md = gtk.MessageDialog(	parent = self,
										flags = gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
										type = gtk.MESSAGE_ERROR,
										buttons = gtk.BUTTONS_OK_CANCEL,
										message_format = _('The email or/and the password are incorrect\nplease, try again?'))
				if md.run() == gtk.RESPONSE_CANCEL:
					exit(3)
				md.destroy()
				p = Preferences(self)
				self.load_preferences()
		#
		vbox = gtk.VBox()#spacing = 5)
		#vbox.set_border_width(5)
		self.add(vbox)
		#
		self.menubar = gtk.MenuBar()
		vbox.pack_start(self.menubar,False,False)	
		################################################################
		self.filemenu = gtk.Menu()
		self.filem = gtk.MenuItem(_('File'))
		self.filem.set_submenu(self.filemenu)
		#
		self.sal = gtk.ImageMenuItem(gtk.STOCK_QUIT)
		self.sal.connect('activate',self.close_application)
		self.filemenu.append(self.sal)
		#
		self.menubar.append(self.filem)
		################################################################
		self.fileedit = gtk.Menu()
		self.filee = gtk.MenuItem(_('Edit'))
		self.filee.set_submenu(self.fileedit)
		#
		self.pref = gtk.ImageMenuItem(gtk.STOCK_PREFERENCES)
		self.pref.connect('activate',self.on_preferences_activate)
		self.fileedit.append(self.pref)
		#
		self.download_all = gtk.MenuItem(_('Download all albums'))
		self.download_all.connect('activate',self.on_download_all_activate)
		self.fileedit.append(self.download_all)
		#
		self.menubar.append(self.filee)
		################################################################
		self.filehelp = gtk.Menu()
		self.fileh = gtk.MenuItem(_('Help'))
		self.fileh.set_submenu(self.get_help_menu())
		#
		self.menubar.append(self.fileh)
		################################################################
		#
		vbox1 = gtk.VBox(spacing = 0)
		vbox1.set_border_width(0)
		vbox.add(vbox1)
		#
		hbox = gtk.HBox()
		vbox1.pack_start(hbox,True,True)
		#
		scrolledwindow = gtk.ScrolledWindow()
		scrolledwindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		scrolledwindow.set_shadow_type(gtk.SHADOW_ETCHED_OUT)		
		hbox.pack_start(scrolledwindow,True,True)
		#
		self.iconview1 = gtk.IconView()
		scrolledwindow.add(self.iconview1)
		#
		vbox2 = gtk.VBox(spacing = 0)
		vbox2.set_border_width(5)
		hbox.pack_start(vbox2,False,False)
		#
		self.button1 = gtk.Button()
		self.button1.set_size_request(40,40)
		self.button1.set_tooltip_text(_('Up'))	
		self.button1.set_image(gtk.image_new_from_stock(gtk.STOCK_GO_UP,gtk.ICON_SIZE_BUTTON))
		self.button1.connect('clicked',self.on_button1_clicked)
		self.button1.set_sensitive(False)
		vbox2.pack_start(self.button1,False,False)
		#
		self.button2 = gtk.Button()
		self.button2.set_size_request(40,40)
		self.button2.set_tooltip_text(_('Add'))	
		self.button2.set_image(gtk.image_new_from_stock(gtk.STOCK_ADD,gtk.ICON_SIZE_BUTTON))
		self.button2.connect('clicked',self.on_button2_clicked)
		vbox2.pack_start(self.button2,False,False)
		#
		self.button3 = gtk.Button()
		self.button3.set_size_request(40,40)
		self.button3.set_tooltip_text(_('Remove'))		
		self.button3.set_image(gtk.image_new_from_stock(gtk.STOCK_REMOVE,gtk.ICON_SIZE_BUTTON))
		self.button3.connect('clicked',self.on_remove_button_clicked)
		vbox2.pack_start(self.button3,False,False)
		#
		self.button4 = gtk.Button()
		self.button4.set_size_request(40,40)
		self.button4.set_tooltip_text(_('Exit from Picapy'))		
		self.button4.set_image(gtk.image_new_from_stock(gtk.STOCK_QUIT,gtk.ICON_SIZE_BUTTON))
		self.button4.connect('clicked',self.close_application)
		vbox2.pack_end(self.button4,False,False)
		#
		self.menu_emergente=gtk.Menu()
		self.menuitem3 = gtk.MenuItem(_('Information'))
		self.menuitem3.connect('activate',self.on_informacion_activated)
		self.menu_emergente.append(self.menuitem3)
		self.menuitem4 = gtk.MenuItem(_('Edit'))
		self.menuitem4.connect('activate',self.on_edit_activated)
		self.menu_emergente.append(self.menuitem4)
		self.menuitem5 = gtk.MenuItem(_('Download'))
		self.menuitem5.connect('activate',self.on_descargar_activated)
		self.menu_emergente.append(self.menuitem5)
		self.menuitem6 = gtk.MenuItem(_('Copy link to clipboard'))
		self.menuitem6.connect('activate',self.on_menuitem6_activated)
		self.menu_emergente.append(self.menuitem6)
		self.menuitem7 = gtk.MenuItem(_('Copy thumbnail 72x72 link to clipboard'))
		self.menuitem7.connect('activate',self.on_menuitem7_activated)
		self.menu_emergente.append(self.menuitem7)
		self.menuitem8 = gtk.MenuItem(_('Copy thumbnail 144x144 link to clipboard'))
		self.menuitem8.connect('activate',self.on_menuitem8_activated)
		self.menu_emergente.append(self.menuitem8)
		self.menuitem9 = gtk.MenuItem(_('Copy thumbnail 288x288 link to clipboard'))
		self.menuitem9.connect('activate',self.on_menuitem9_activated)
		self.menu_emergente.append(self.menuitem9)
		self.menuitem10 = gtk.MenuItem(_('Copy link for web'))
		self.menuitem10.connect('activate',self.on_menuitem10_activated)
		self.menu_emergente.append(self.menuitem10)
		#
		self.menuitem3.set_visible(True)
		self.menuitem4.set_visible(True)
		self.menuitem5.set_visible(True)
		self.menuitem6.set_visible(True)
		self.menuitem7.set_visible(True)
		self.menuitem8.set_visible(True)
		self.menuitem9.set_visible(True)		
		self.menuitem10.set_visible(True)
		#
		self.store = gtk.ListStore(gtk.gdk.Pixbuf,str,gobject.TYPE_PYOBJECT)
		self.storeimages = gtk.ListStore(gtk.gdk.Pixbuf,str,gobject.TYPE_PYOBJECT)
		self.iconview1.set_model(self.store)
		self.iconview1.set_selection_mode(gtk.SELECTION_MULTIPLE)
		self.iconview1.set_pixbuf_column(0)
		self.iconview1.set_text_column(1)
		self.iconview1.set_columns(6)
		self.iconview1.set_item_width(100)
		#self.iconview1.enable_model_drag_source( gtk.gdk.BUTTON1_MASK, self.TARGETS, gtk.gdk.ACTION_DEFAULT|gtk.gdk.ACTION_MOVE)		
		#( "image/x-xpixmap", 0, TARGET_TYPE_PIXMAP )
		self.iconview1.drag_dest_set(gtk.DEST_DEFAULT_MOTION |gtk.DEST_DEFAULT_HIGHLIGHT |gtk.DEST_DEFAULT_DROP, [( "text/plain",0,TARGET_TYPE_TEXT)],gtk.gdk.ACTION_COPY)
		self.iconview1.connect('button-press-event',self.on_iconview1_button_press_event)
		self.iconview1.connect('button-release-event',self.on_iconview1_button_release_event)
		self.iconview1.connect('key-release-event',self.on_iconview1_key_release_event)
		#self.iconview1.connect('drag_drop',self.drop)
		#self.iconview1.connect('drag_data_get', self.drag_data_get_data)
		#self.iconview1.connect('drag_motion', self.motion)
		self.iconview1.connect('drag-data-received',self.drag_data_received)
		self.iconview1.connect("drag_data_get", self.drag_data_get_data)
		self.iconview1.drag_source_set(gtk.gdk.BUTTON1_MASK, [('text/uri-list',0,100)],gtk.gdk.ACTION_COPY)		
		#self.iconview1.drag_source_set(gtk.gdk.BUTTON1_MASK, [('text/plain',0,80)],gtk.gdk.ACTION_COPY)		
		#
		self.show_all()
		#
		self.inicia_albums()
		self.album=None
		
	def drag_data_get_data(self, treeview, context, selection, target_id, etime):
		print 'target %s'%target_id
		if target_id == 100:
			if self.album==None:
				'''
				selected=self.store.get_iter_from_string(str(items[0][0]))
				album=self.store.get_value(selected,2)
				photos=self.picasa.get_photos_from_album(album.gphoto_id.text)
				p=Progreso(_('Downloading all images from album...'),self,len(photos.entry))
				for photo in photos.entry:
					while threading.activeCount()>9:
						time.sleep(0.05)
					saver = Saver(photo,folder)
					saver.start()
					while threading.activeCount()>1:
						time.sleep(0.05)
					p.increase()
				p.destroy()
				'''
				pass
			else:	
				items = self.iconview1.get_selected_items()
				if len(items)>0:
					selected=self.storeimages.get_iter_from_string(str(items[0][0]))
					imagen=self.storeimages.get_value(selected,2)
					if imagen.content.src[imagen.content.src.rfind('/')]>-1:
						ext = imagen.content.src[-4:]
						name = self.storeimages.get_value(selected,1)
						if name[-4:] != ext:
							name =name+ext
						filename = tempfile.mkstemp(suffix = '',prefix='picapy_tmp', dir='/tmp')[1]
						self.download_image(imagen.content.src,filename)
						if os.path.exists(filename):
							newname = os.path.join('/tmp',name)
							os.rename(filename,newname)
							selection.set(selection.target, 8, 'file://'+newname)
							if os.path.exists(filename):
								os.delete(filename)

	def drop(self,widget,context,x,y,time):
		print 'drop'
		print context.targets
		print '\n'.join([str(t) for t in context.targets])
		context.finish(True, False, time)
		print context.targets[1]

	def drag_data_received(self,widget, drag_context, x, y, selection_data, info, timestamp):
		print 'data_received'
		print selection_data.get_text()
		if self.album==None:
			pass
		else:
			filenames = selection_data.get_text().split('\n')
			for_upload = []
			for filename in filenames:
				if len(filename)>8:
					filename = urllib.url2pathname(filename)
					filename = filename[7:]
					mime = mimetypes.guess_type(filename)
					if os.path.exists(filename):
						mime = mimetypes.guess_type(filename)[0]
						print mime
						if mime in picasa.SUPPORTED_MIMES or mime in picasa.CONVERTED_MIMES:
							print filename
							for_upload.append(filename)
			print len(for_upload)
			if len(for_upload)>0:
				p=Progreso(_('Uploading images...'),self,len(for_upload))
				for filename in for_upload:
					while threading.activeCount()>9:
						time.sleep(0.05)
						self.map()
						while gtk.events_pending():
							gtk.main_iteration()					
					uploader = Uploader(p,self,filename,self.album,self.picasa,self.storeimages,self.max_size,self.reduce_colors)
					uploader.start()
				while threading.activeCount()>1:
					time.sleep(0.05)
					self.map()
					while gtk.events_pending():
						gtk.main_iteration()				
				p.destroy()
		return True

	def motion(self,widget, context, x, y, time):
	   print "motion"
	   context.drag_status(gtk.gdk.ACTION_COPY, time)
	   return True		
	def load_preferences(self):
		if gkconfiguration.exists_configuration() == True:
			conf = gkconfiguration.get_configuration()
			self.user = conf['email']
			self.password = conf['password']
			self.image_link = conf['image_link']
			self.max_size = conf['max_size']
			self.reduce_colors = conf['reduce_colors']
	def get_help_menu(self):
		help_menu =gtk.Menu()
		#		
		add2menu(help_menu,text = _('Web...'),conector_event = 'activate',conector_action = self.on_menu_project_clicked)
		add2menu(help_menu,text = _('Get help online...'),conector_event = 'activate',conector_action = self.on_menu_help_online_clicked)
		add2menu(help_menu,text = _('Translate this application...'),conector_event = 'activate',conector_action = self.on_menu_translations_clicked)
		add2menu(help_menu,text = _('Report a bug...'),conector_event = 'activate',conector_action = self.on_menu_bugs_clicked)
		add2menu(help_menu)
		add2menu(help_menu,text = _('About'),conector_event = 'activate',conector_action = self.on_about_activate)
		#
		help_menu.show()
		#
		return help_menu
		
	def on_menu_project_clicked(self,widget):
		webbrowser.open('https://launchpad.net/picapy')
		
	def on_menu_help_online_clicked(self,widget):
		webbrowser.open('https://answers.launchpad.net/picapy')
	
	def on_menu_translations_clicked(self,widget):
		webbrowser.open('https://translations.launchpad.net/picapy')
	
	def on_menu_bugs_clicked(self,widget):
		webbrowser.open('https://bugs.launchpad.net/picapy')
		
	def inicia_images(self):
		modelo = gtk.ListStore(str)
		self.treeview2.set_model(modelo)
		render=gtk.CellRendererText()
		columna=gtk.TreeViewColumn("Imagen",render,text=0)
		self.treeview2.append_column(columna)
		#
	def close_application(self,widget):
		exit(0)
		
	def append_album(self,album):
		if album.access.text == 'public':
			pixbuf = gtk.gdk.pixbuf_new_from_file(filepath('folder_public.png'))
		elif album.access.text == 'protected':
			pixbuf = gtk.gdk.pixbuf_new_from_file(filepath('folder_private.png'))
		elif album.access.text == 'private':
			pixbuf = gtk.gdk.pixbuf_new_from_file(filepath('folder_protected.png'))
		album_name=album.title.text
		self.store.append([pixbuf,album_name,album])		
	#
	# Added only for insert new album
	#
	def prepend_album(self,album):
		if album.access.text == 'public':
			pixbuf = gtk.gdk.pixbuf_new_from_file(filepath('folder_public.png'))
		elif album.access.text == 'protected':
			pixbuf = gtk.gdk.pixbuf_new_from_file(filepath('folder_private.png'))
		elif album.access.text == 'private':
			pixbuf = gtk.gdk.pixbuf_new_from_file(filepath('folder_protected.png'))
		album_name=album.title.text
		self.store.prepend([pixbuf,album_name,album])		
	
	def inicia_albums(self):
		self.store.clear()
		self.albums=[]
		self.albums=self.picasa.get_albums()
		for album in self.albums.entry:
			self.append_album(album)
			
	def on_edit_activated(self,widget):
		items = self.iconview1.get_selected_items()
		if len(items)>0:
			if self.album==None:
				selected=self.store.get_iter_from_string(str(items[0][0]))
				album = self.store.get_value(selected,2)
				i=EditAlbum(self,album)				
				if i.run() == gtk.RESPONSE_ACCEPT:
					album.title.text = i.entry1.get_text()
					album.summary.text = i.entry2.get_text()
					if i.combobox.get_active() == 0:
						album.access.text = 'private'
					elif i.combobox.get_active() == 1:
						album.access.text = 'protected'
					else:
						album.access.text = 'public'
					updated_album = self.picasa.edit_album(album)
					if updated_album.access.text == 'public':
						pixbuf = gtk.gdk.pixbuf_new_from_file(filepath('folder_public.png'))
					elif updated_album.access.text == 'protected':
						pixbuf = gtk.gdk.pixbuf_new_from_file(filepath('folder_private.png'))
					elif updated_album.access.text == 'private':
						pixbuf = gtk.gdk.pixbuf_new_from_file(filepath('folder_protected.png'))
					album_name=album.title.text
					self.store.set_value(selected,0,pixbuf)
					self.store.set_value(selected,1,updated_album.title.text)
					self.store.set_value(selected,2,updated_album)
					self.inicia_albums()
				i.destroy()
			else:
				selected=self.storeimages.get_iter_from_string(str(items[0][0]))
				image = self.storeimages.get_value(selected,2)
				i=EditImage(self,image)				
				if i.run() == gtk.RESPONSE_ACCEPT:
					image.title.text = i.entry1.get_text()
					image.summary.text = i.entry2.get_text()
					if not image.media:
						image.media = gdata.media.Group()
					if not image.media.keywords:
						image.media.keywords = gdata.media.Keywords()
					image.media.keywords.text = i.entry3.get_text()
					print image.media.keywords.text
					updated_image = self.picasa.edit_image(image)
					image_name = updated_image.title.text
					self.storeimages.set_value(selected,1,updated_image.title.text)
					self.storeimages.set_value(selected,2,updated_image)
				i.destroy()

	def on_informacion_activated(self,widget):
		items = self.iconview1.get_selected_items()
		if len(items)>0:
			if self.album==None:
				selected=self.store.get_iter_from_string(str(items[0][0]))
				i=InformacionAlbum(self,self.store.get_value(selected,2))
				i.run()
				i.destroy()
			else:
				selected=self.storeimages.get_iter_from_string(str(items[0][0]))
				i=InformacionImagen(self,self.storeimages.get_value(selected,2))
				i.run()
				i.destroy()

	def on_preferences_activate(self,widget):
		p = Preferences(self)
		self.load_preferences()
		error = True
		while error:
			try:
				self.picasa=Picasa(self.user,self.password)
				error = False
			#except BadAuthentication:
			except:
				error = True
				md = gtk.MessageDialog(	parent = self,
										flags = gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
										type = gtk.MESSAGE_ERROR,
										buttons = gtk.BUTTONS_OK_CANCEL,
										message_format = _('The email or/and the password are incorrect\nplease, try again?'))
				if md.run() == gtk.RESPONSE_CANCEL:
					exit(3)
				md.destroy()
				p = Preferences(self)
				self.load_preferences()			
		self.inicia_albums()
		self.iconview1.set_model(self.store)		
		self.button1.set_sensitive(False)
		self.album=None
		self.set_title('Picapy')
	def on_download_all_activate(self,widget):
		chooser = gtk.FileChooserDialog(title=_('Select where to download all albums'),parent=self,action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
		if chooser.run() == gtk.RESPONSE_OK:
			filename=chooser.get_filename()
			chooser.destroy()
			albums=self.picasa.get_albums()
			p=Progreso(_('Downloading all albums...'),self,len(albums.entry))
			for album in albums.entry:
				folder = os.path.join(filename,album.title.text)
				if not os.path.exists(folder):
					os.mkdir(folder)
				photos=self.picasa.get_photos_from_album(album.gphoto_id.text)
				for photo in photos.entry:
					while threading.activeCount()>9:
						time.sleep(0.05)
					saver = Saver(photo,folder)
					saver.start()
					while threading.activeCount()>1:
						time.sleep(0.05)
				p.increase()
			p.destroy()
		chooser.destroy()
		
	def on_about_activate(self,widget):
		ad=gtk.AboutDialog()
		ad.set_name(comun.APPNAME)
		ad.set_version(comun.VERSION)
		ad.set_copyright('Copyrignt (c) 2010-2011\nLorenzo Carbonell')
		ad.set_comments(_('An application to manage your images in\nPicasa Web'))
		ad.set_license(''+
		'This program is free software: you can redistribute it and/or modify it\n'+
		'under the terms of the GNU General Public License as published by the\n'+
		'Free Software Foundation, either version 3 of the License, or (at your option)\n'+
		'any later version.\n\n'+
		'This program is distributed in the hope that it will be useful, but\n'+
		'WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY\n'+
		'or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for\n'+
		'more details.\n\n'+
		'You should have received a copy of the GNU General Public License along with\n'+
		'this program.  If not, see <http://www.gnu.org/licenses/>.')
		ad.set_website('http://www.atareao.es')
		ad.set_website_label('http://www.atareao.es')
		ad.set_authors(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_documenters(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_translator_credits(''+
		'Dario Villar Veres <dario.villar.v@gmail.com>\n'+
		'Bernardo Miguel	Savone <bmsavone@gmail.com>\n'+
		'Enbata <peionz@euskalnet.net>\n'+
		'Mario Blättermann <mariobl@gnome.org>\n'+
		'Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>\n'+
		'zeugma <https://launchpad.net/~sunder67>\n'+
		'Alin Andrei <https://launchpad.net/~nilarimogard>\n'+
		'Fitoschido <fitoschido@gmail.com>\n'+
		'Daniele Lucarelli <https://launchpad.net/~ldanivvero>\n'+
		'Alejandro Martín Covarrubias <alex.covarrubias@gmail.com>\n'+
		'Rustam Vafin\n'+
		'elmodos\n'+
		'extraymond@gmail.com <extraymond@gmail.com>\n'+
		'fgp <https://launchpad.net/~komakino>\n')
		ad.set_program_name('Picapy')
		ad.set_logo(gtk.gdk.pixbuf_new_from_file(filepath('picapy.svg')))
		ad.run()
		ad.destroy()
		
	def on_descargar_activated(self,widget):
		items = self.iconview1.get_selected_items()
		if len(items)>0:
			if self.album==None:
				selected=self.store.get_iter_from_string(str(items[0][0]))
				album=self.store.get_value(selected,2)
				chooser = gtk.FileChooserDialog(title=_('Select where to download the album'),parent=self,action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
				if chooser.run() == gtk.RESPONSE_OK:
					filename=chooser.get_filename()
					chooser.destroy()
					albums=self.picasa.get_albums()
					folder = os.path.join(filename,album.title.text)
					if not os.path.exists(folder):
						os.mkdir(folder)
					photos=self.picasa.get_photos_from_album(album.gphoto_id.text)
					p=Progreso(_('Downloading all images from album...'),self,len(photos.entry))
					for photo in photos.entry:
						while threading.activeCount()>9:
							time.sleep(0.05)
						saver = Saver(photo,folder)
						saver.start()
						while threading.activeCount()>1:
							time.sleep(0.05)
						p.increase()
					p.destroy()
				chooser.destroy()
			else:
				selected=self.storeimages.get_iter_from_string(str(items[0][0]))
				imagen=self.storeimages.get_value(selected,2)
				chooser = gtk.FileChooserDialog(title=_('Select filename for image'),parent=self,action=gtk.FILE_CHOOSER_ACTION_SAVE,buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
				if imagen.content.src[imagen.content.src.rfind('/')]>-1:
					fn = imagen.content.src[imagen.content.src.rfind('/')+1:]
					chooser.set_current_name(fn)
				response=chooser.run()
				if response == gtk.RESPONSE_OK:
					filename=chooser.get_filename()
					chooser.destroy()
					self.download_image(imagen.content.src,filename)
				else:
					chooser.destroy()
				
			
	def on_menuitem6_activated(self,widget):
		items = self.iconview1.get_selected_items()
		if len(items)>0:
			clipboard = gtk.clipboard_get()
			selected=self.storeimages.get_iter_from_string(str(items[0][0]))
			imagen=self.storeimages.get_value(selected,2)
			clipboard.set_text(imagen.content.src)
			clipboard.store()

	def on_menuitem7_activated(self,widget):
		items = self.iconview1.get_selected_items()
		if len(items)>0:
			clipboard = gtk.clipboard_get()
			selected=self.storeimages.get_iter_from_string(str(items[0][0]))
			imagen=self.storeimages.get_value(selected,2)
			clipboard.set_text(imagen.media.thumbnail[0].url)
			clipboard.store()

	def on_menuitem8_activated(self,widget):
		items = self.iconview1.get_selected_items()
		if len(items)>0:
			clipboard = gtk.clipboard_get()
			selected=self.storeimages.get_iter_from_string(str(items[0][0]))
			imagen=self.storeimages.get_value(selected,2)
			clipboard.set_text(imagen.media.thumbnail[1].url)
			clipboard.store()

	def on_menuitem9_activated(self,widget):
		items = self.iconview1.get_selected_items()
		if len(items)>0:
			clipboard = gtk.clipboard_get()
			selected=self.storeimages.get_iter_from_string(str(items[0][0]))
			imagen=self.storeimages.get_value(selected,2)
			clipboard.set_text(imagen.media.thumbnail[2].url)
			clipboard.store()

	def on_menuitem10_activated(self,widget):
		items = self.iconview1.get_selected_items()
		if len(items)>0:
			clipboard = gtk.clipboard_get()
			selected=self.storeimages.get_iter_from_string(str(items[0][0]))
			imagen=self.storeimages.get_value(selected,2)
			#text = '<a class="highslide" title="%TITLE%" onclick="return hs.expand(this)" href="%URL%"> <img class="aligncenter" title="%TITLE%" src="%URL288%" alt="%TITLE%"/></a>'
			text = self.image_link
			text = text.replace('%TITLE%',imagen.title.text)
			text = text.replace('%URL%',imagen.content.src)
			text = text.replace('%URL72%',imagen.media.thumbnail[0].url)
			text = text.replace('%URL144%',imagen.media.thumbnail[1].url)
			text = text.replace('%URL288%',imagen.media.thumbnail[2].url)
			clipboard.set_text(text)
			clipboard.store()		
	def on_iconview1_button_press_event(self,widget,event):
		if event.button==1 and event.type==gtk.gdk._2BUTTON_PRESS:
			if self.album==None:
				items = self.iconview1.get_selected_items()
				if len(items)>0:
					selected=self.store.get_iter_from_string(str(items[0][0]))
					self.load_images_from_picasa_album(self.store.get_value(selected,2))
			else:
				items = self.iconview1.get_selected_items()
				if len(items)>0:
					selected=self.storeimages.get_iter_from_string(str(items[0][0]))
					image=self.storeimages.get_value(selected,2)
					v = VerImagen(self,image)
					v.run()
					v.destroy()
					
	def on_iconview1_button_release_event(self,widget,event):
		if event.button == 3:
			items = self.iconview1.get_selected_items()
			if len(items)>0:
				if self.album == None:
					self.menuitem4.set_sensitive(True)
					self.menuitem5.set_sensitive(True)
					self.menuitem6.set_sensitive(False)
					self.menuitem7.set_sensitive(False)
					self.menuitem8.set_sensitive(False)
					self.menuitem9.set_sensitive(False)
					self.menuitem10.set_sensitive(False)
				else:
					self.menuitem3.set_sensitive(True)
					self.menuitem4.set_sensitive(True)
					self.menuitem5.set_sensitive(True)
					self.menuitem6.set_sensitive(True)
					self.menuitem7.set_sensitive(True)
					self.menuitem8.set_sensitive(True)
					self.menuitem9.set_sensitive(True)
					self.menuitem10.set_sensitive(True)
				self.menu_emergente.popup( None, None, None, event.button,0)
	def on_iconview1_key_release_event(self,widget,event):
		values = []
		values.append(gtk.gdk.keyval_from_name('Return'))
		values.append(gtk.gdk.keyval_from_name('KP_Enter'))
		values.append(gtk.gdk.keyval_from_name('space'))
		if event.keyval in values:
			if self.album==None:
				items = self.iconview1.get_selected_items()
				if len(items)>0:
					selected=self.store.get_iter_from_string(str(items[0][0]))
					self.load_images_from_picasa_album(self.store.get_value(selected,2))
			else:
				items = self.iconview1.get_selected_items()
				if len(items)>0:
					selected=self.storeimages.get_iter_from_string(str(items[0][0]))
					image=self.storeimages.get_value(selected,2)
					v = VerImagen(self,image)
					v.run()
					v.destroy()	
		elif event.keyval == gtk.gdk.keyval_from_name('BackSpace'):
			if self.album != None:
				self.iconview1.set_model(self.store)		
				self.button1.set_sensitive(False)
				self.album=None
				self.set_title('Picapy')

	def load_images_from_picasa_album(self,album):
		self.set_title('Picapy | ' + album.title.text)
		photos=self.picasa.get_photos_from_album(album.gphoto_id.text)
		self.storeimages.clear()
		self.iconview1.set_model(self.storeimages)
		# dm = DownloaderManager(photos.entry,self.storeimages)
		# dm.download()
		total = len(photos.entry)
		if total > 0:
			p=Progreso(_('Loading images...'),self,total)
			for photo in photos.entry:
				while threading.activeCount()>9:
					time.sleep(0.05)
				downloader = Downloader(photo,self.storeimages)
				downloader.start()
				p.increase()
			while threading.activeCount()>1:
				time.sleep(0.05)
			p.close()
		self.iconview1.show()
		self.album=album
		self.button1.set_sensitive(True)
						
	def on_button1_clicked(self,widget):
		self.iconview1.set_model(self.store)		
		self.button1.set_sensitive(False)
		self.album=None
		self.set_title('Picapy')
			
	def on_remove_button_clicked(self,widget):
		if self.album==None:
			items = self.iconview1.get_selected_items()
			if len(items)>0:
				if len(items)>1:
					msg = _('Do you want to delete %s folders?') % str(len(items))
					msg2 = _('Deleting folders...')
				else:
					msg = _('Do you want to delete this folder?')
					msg2 = _('Deleting folder...')
				md = gtk.MessageDialog(self, 
				gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_QUESTION, 
				gtk.BUTTONS_OK_CANCEL, msg)
				respuesta=md.run()
				if respuesta == gtk.RESPONSE_OK:
					md.destroy()
					p=Progreso(msg2,self,len(items))
					for item in items:
						itera = self.store.get_iter_from_string(str(item[0]))
						selected=self.store.get_value(itera,2)
						self.picasa.delete_album(selected)
						p.increase()
						self.store.remove(itera)
						#self.storeimages.remove(itera)
						# modificado ahora cada vez que se elimina una imagen se hace directamente no 
						# es necesario recargar todo el album
						# antes: self.inicia_albums()
					p.destroy()
				else:
					md.destroy()
		else:
			items = self.iconview1.get_selected_items()
			if len(items)>0:
				if len(items)>1:
					msg = _('Do you want to delete %s images?') % str(len(items))
					msg2 = _('Deleting images...')
				else:
					msg = _('Do you want to delete this image?')
					msg2 = _('Deleting image...')
				md = gtk.MessageDialog(self, 
				gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_QUESTION, 
				gtk.BUTTONS_OK_CANCEL, msg)
				respuesta=md.run()
				if respuesta == gtk.RESPONSE_OK:			
					md.destroy()
					p=Progreso(msg2,self,len(items))
					for item in items:
						itera = self.storeimages.get_iter_from_string(str(item[0]))
						selected=self.storeimages.get_value(itera,2)
						self.picasa.delete_image(selected)
						p.increase()
						# modificado ahora cada vez que se elimina una imagen se hace directamente no 
						# es necesario recargar todo el album
						# antes: self.load_images_from_picasa_album(self.album)
						self.storeimages.remove(itera)
					p.destroy()
				else:
					md.destroy()
			
	def update_preview_cb(self,file_chooser, preview):
		filename = file_chooser.get_preview_filename()
		try:
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(filename, 128, 128)
			preview.set_from_pixbuf(pixbuf)
			have_preview = True
		except:
			have_preview = False
		file_chooser.set_preview_widget_active(have_preview)
		return

	def on_button2_clicked(self,widget):
		if self.album==None:
			n=NuevoAlbum(self)
			if n.run() == gtk.RESPONSE_ACCEPT:
				album=n.get_album()
				commentary = n.get_commentary()
				access = n.get_access()
				if len(album)>0:
					album=self.picasa.add_album(album,commentary,access)
					# added: así no tengo que subir todos los album cada vez que creo uno
					self.prepend_album(album)
					# self.inicia_albums()
			n.destroy()	
		else:
			dialog = gtk.FileChooserDialog(_('Select one or more images to upload to Picasa Web'),
											self,
										   gtk.FILE_CHOOSER_ACTION_OPEN,
										   (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
											gtk.STOCK_OPEN, gtk.RESPONSE_OK))
			dialog.set_default_response(gtk.RESPONSE_OK)
			dialog.set_select_multiple(True)
			dialog.set_current_folder(os.getenv('HOME'))
			filter = gtk.FileFilter()
			filter.set_name(_('Imagenes'))
			filter.add_mime_type('image/png')
			filter.add_mime_type('image/jpeg')
			filter.add_mime_type('image/gif')
			filter.add_mime_type('image/x-ms-bmp')
			filter.add_mime_type('image/x-icon')
			filter.add_mime_type('image/tiff')
			filter.add_mime_type('image/x-photoshop')
			filter.add_mime_type('x-portable-pixmap')
			filter.add_pattern('*.png')
			filter.add_pattern('*.jpg')
			filter.add_pattern('*.gif')
			filter.add_pattern('*.bmp')
			filter.add_pattern('*.ico')
			filter.add_pattern('*.tiff')
			filter.add_pattern('*.psd')
			filter.add_pattern('*.ppm')
			dialog.add_filter(filter)
			preview = gtk.Image()
			dialog.set_preview_widget(preview)
			dialog.connect('update-preview', self.update_preview_cb, preview)
			response = dialog.run()
			if response == gtk.RESPONSE_OK:
				filenames = dialog.get_filenames()
				dialog.destroy()
				p=Progreso(_('Uploading images...'),self,len(filenames))
				for filename in filenames:
					while threading.activeCount()>9:
						time.sleep(0.05)
						self.map()
						while gtk.events_pending():
							gtk.main_iteration()					
					uploader = Uploader(p,self,filename,self.album,self.picasa,self.storeimages,self.max_size,self.reduce_colors)
					uploader.start()
				while threading.activeCount()>1:
					time.sleep(0.05)
					self.map()
					while gtk.events_pending():
						gtk.main_iteration()				
				p.destroy()
			else:
				dialog.destroy()
		
	def download_image(self,url_image,filename):
		opener1 = urllib2.build_opener()
		page1 = opener1.open(url_image)
		my_picture = page1.read()
		#
		fout = open(filename, "wb")
		fout.write(my_picture)
		fout.close()
'''
	def load_key(self,key,defecto):
		gconfi = GConf()
		PATH = '/apps/picapy/options/'+key
		try:
			valor = gconfi.get_key(PATH)
			return valor
		except ValueError:
			gconfi.set_key(PATH,defecto)
		return defecto
'''
if __name__ == "__main__":
	v = Picapy()
	gtk.main()
