#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='atareao'
__date__ ='$06-jun-2010 12:34:44$'
#
# <one line to give the program's name and a brief idea of what it does.>
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#

import gtk
import locale
import gettext
import gkconfiguration
import comun

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(comun.APP, comun.LANGDIR)
gettext.textdomain(comun.APP)
_ = gettext.gettext


class Preferences(gtk.Dialog):
	def __init__(self,parent):
		self.ok = False
		#
		title = comun.APP + ' | '+_('Preferences')
		gtk.Dialog.__init__(self, title,parent,gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,(gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT,gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
		self.set_size_request(400, 320)
		self.set_resizable(False)
		self.set_icon(gtk.gdk.pixbuf_new_from_file(comun.ICON))		
		self.connect('destroy', self.close_application)
		#
		vbox0 = gtk.VBox(spacing = 5)
		vbox0.set_border_width(5)
		self.get_content_area().add(vbox0)
		#
		notebook = gtk.Notebook()
		vbox0.add(notebook)
		#
		frame0 = gtk.Frame()
		notebook.append_page(frame0,tab_label = gtk.Label(_('Login')))
		#vbox0.pack_start(frame0,False,False)
		#
		table = gtk.Table(rows = 2, columns = 2, homogeneous = False)
		table.set_border_width(5)
		table.set_col_spacings(5)
		table.set_row_spacings(5)
		frame0.add(table)
		#
		label11 = gtk.Label(_('User')+':')
		label11.set_alignment(0,.5)
		table.attach(label11,0,1,0,1, xoptions = gtk.FILL, yoptions = gtk.SHRINK)
		#
		label12 = gtk.Label(_('Password')+':')
		label12.set_alignment(0,.5)
		table.attach(label12,0,1,1,2, xoptions = gtk.FILL, yoptions = gtk.SHRINK)
		#
		self.entry1 = gtk.Entry()
		self.entry1.set_width_chars(30)
		table.attach(self.entry1,1,2,0,1, xoptions = gtk.EXPAND, yoptions = gtk.SHRINK)
		#
		self.entry2 = gtk.Entry()
		self.entry2.set_visibility(False)
		self.entry2.set_width_chars(30)
		table.attach(self.entry2,1,2,1,2, xoptions = gtk.EXPAND, yoptions = gtk.SHRINK)
		#
		frame1 = gtk.Frame()
		notebook.append_page(frame1,tab_label = gtk.Label(_('Image link')))
		#
		vbox1 = gtk.VBox(spacing = 5)
		vbox1.set_border_width(5)
		frame1.add(vbox1)
		#
		label21 = gtk.Label(_('Title')+' -> %TITLE%')
		label21.set_alignment(0,.5)
		vbox1.pack_start(label21,True,True)
		label22 = gtk.Label(_('Image')+' Url -> %URL%')
		label22.set_alignment(0,.5)
		vbox1.pack_start(label22,True,True)
		label23 = gtk.Label(_('Thumbnail')+' Url 72 pixel -> %URL72%')
		label23.set_alignment(0,.5)
		vbox1.pack_start(label23,True,True)
		label24 = gtk.Label(_('Thumbnail')+' Url 144 pixel -> %URL144%')
		label24.set_alignment(0,.5)
		vbox1.pack_start(label24,True,True)
		label25 = gtk.Label(_('Thumbnail')+' Url 288 pixel -> %URL288%')
		label25.set_alignment(0,.5)
		vbox1.pack_start(label25,True,True)
		label26 = gtk.Label(_('Set image link:'))
		label26.set_alignment(0,.5)
		scrolledwindow = gtk.ScrolledWindow()
		scrolledwindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		scrolledwindow.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
		vbox1.pack_start(scrolledwindow,True,True)
		self.entry3 = gtk.TextView()
		self.entry3.set_wrap_mode(gtk.WRAP_WORD)
		self.entry3.set_border_width(5)
		scrolledwindow.add(self.entry3)
		#
		frame2 = gtk.Frame()
		notebook.append_page(frame2,tab_label = gtk.Label(_('Optimization')))
		#
		vbox2 = gtk.VBox(spacing = 5)
		vbox2.set_border_width(5)
		frame2.add(vbox2)
		#
		self.checkbutton21 = gtk.CheckButton(_('Maximum size 800 pixels'))
		vbox2.pack_start(self.checkbutton21,False,False)
		#
		self.checkbutton22 = gtk.CheckButton(_('Reduce colors'))
		vbox2.pack_start(self.checkbutton22,False,False)
		#
		hbox26 = gtk.HBox()
		hbox26.set_border_width(5)
		vbox0.pack_start(hbox26,False,False)
		#
		self.load_preferences()
		#
		self.show_all()
		#
		if self.run() == gtk.RESPONSE_ACCEPT:
			self.ok = True
			self.save_preferences()
		self.destroy()
		

	def load_preferences(self):
		if gkconfiguration.exists_configuration() == True:
			conf = gkconfiguration.get_configuration()
			self.user = conf['email']
			self.password = conf['password']
			self.image_link = conf['image_link']
			max_size = conf['max_size']
			reduce_colors = conf['reduce_colors']
			#
			self.entry1.set_text(self.user)
			self.entry2.set_text(self.password)
			ttbuffer=gtk.TextBuffer()
			ttbuffer.set_text(self.image_link)
			self.entry3.set_buffer(ttbuffer)
			self.checkbutton21.set_active(max_size)
			self.checkbutton22.set_active(reduce_colors)
				
	def save_preferences(self):
		email = self.entry1.get_text()
		password = self.entry2.get_text()
		tbuffer =self.entry3.get_buffer()
		inicio = tbuffer.get_start_iter()
		fin = tbuffer.get_end_iter()
		image_link = tbuffer.get_text(inicio,fin)
		max_size = self.checkbutton21.get_active()
		reduce_colors = self.checkbutton22.get_active()
		gkconfiguration.set_configuration(email,password,image_link=image_link,max_size=max_size,reduce_colors=reduce_colors)

	def close_application(self,widget):
		self.ok = False
		self.hide()
		self.destroy()
	
if __name__ == "__main__":
	p = Preferences(None)
	exit(0)
		
